'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _clearCanvas = require('clear-canvas');

var _clearCanvas2 = _interopRequireDefault(_clearCanvas);

var _drawToCanvas = require('draw-to-canvas');

var _drawToCanvas2 = _interopRequireDefault(_drawToCanvas);

var _resizeCanvas = require('resize-canvas');

var _resizeCanvas2 = _interopRequireDefault(_resizeCanvas);

var _copyCanvas = require('copy-canvas');

var _copyCanvas2 = _interopRequireDefault(_copyCanvas);

var _glVec2Add = require('gl-vec2/add');

var _glVec2Add2 = _interopRequireDefault(_glVec2Add);

var _glVec2Max = require('gl-vec2/max');

var _glVec2Max2 = _interopRequireDefault(_glVec2Max);

var _glVec2Min = require('gl-vec2/min');

var _glVec2Min2 = _interopRequireDefault(_glVec2Min);

var _glVec2Subtract = require('gl-vec2/subtract');

var _glVec2Subtract2 = _interopRequireDefault(_glVec2Subtract);

// utility functions
var getDimensions = function getDimensions(canvas) {
  return [canvas.width, canvas.height];
};
var abs = function abs(arr) {
  return arr.map(Math.abs);
};

// calculate where to scale from. If x or y is positive, scale from 0
// otherwise scale from bottom or right
function getResizeFrom(canvas, originDiff) {
  var resizeFrom = getDimensions(canvas);
  if (originDiff[0] <= 0) resizeFrom[0] = 0;
  if (originDiff[1] <= 0) resizeFrom[1] = 0;
  return resizeFrom;
}

var InfiniteCanvas = (function () {
  function InfiniteCanvas(canvas) {
    _classCallCheck(this, InfiniteCanvas);

    // optional new keyword
    if (!(this instanceof InfiniteCanvas)) {
      return new InfiniteCanvas(canvas);
    }

    // instantiate
    this.canvas = canvas;
    this.canvasContext = canvas.getContext('2d');
    this.buffer = (0, _copyCanvas2['default'])(canvas);
    this.bufferContext = this.buffer.getContext('2d');
    this.origin = [0, 0];
    this._originMax = [0, 0];
    this._originMin = [0, 0];
    this._originDraw = [0, 0];
  }

  // set the absolute [x, y] origin position of the buffer canvas on
  // the main canvas to pan around

  _createClass(InfiniteCanvas, [{
    key: 'setOrigin',
    value: function setOrigin(newOrigin) {

      // update origins
      var originDiff = (0, _glVec2Subtract2['default'])([], newOrigin, this.origin);
      this.origin = newOrigin;
      this._originMax = (0, _glVec2Max2['default'])([], this.origin, this._originMax);
      this._originMin = (0, _glVec2Min2['default'])([], this.origin, this._originMin);

      // get dimensions
      var canvasDimensions = getDimensions(this.canvas);
      var bufferDimensions = getDimensions(this.buffer);
      var maxDimensions = (0, _glVec2Add2['default'])([], canvasDimensions, (0, _glVec2Add2['default'])([], this._originMax, abs(this._originMin)));

      // resize
      var maxDimensionsDiff = (0, _glVec2Subtract2['default'])([], maxDimensions, bufferDimensions);
      this.buffer = (0, _resizeCanvas2['default'])(this.buffer, maxDimensionsDiff, getResizeFrom(this.buffer, originDiff));

      // redraw
      this._originDraw = (0, _glVec2Min2['default'])([], [0, 0], (0, _glVec2Add2['default'])([], this._originDraw, originDiff));
      this.refresh();
    }

    // pan with relative [x, y] values
  }, {
    key: 'move',
    value: function move(originDiff) {
      this.setOrigin((0, _glVec2Add2['default'])([], this.origin, originDiff));
    }

    // copy whatever was drawn on the canvas to the buffer
  }, {
    key: 'commitToBuffer',
    value: function commitToBuffer() {
      (0, _drawToCanvas2['default'])(this.canvas, this.bufferContext, this.origin);
    }

    // redraw to the canvas from the buffer
  }, {
    key: 'refresh',
    value: function refresh() {

      // erase canvas
      (0, _clearCanvas2['default'])(this.canvasContext);

      // draw to canvas
      (0, _drawToCanvas2['default'])(this.buffer, this.canvasContext, this._originDraw);
    }
  }]);

  return InfiniteCanvas;
})();

exports['default'] = InfiniteCanvas;
module.exports = exports['default'];

